﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using Word = Microsoft.Office.Interop.Word;
using System.Windows.Forms;
using System.Reflection;

namespace MySpellCheck
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
      this.textBox1.Text = "Я пришел на работу и заснул. Урр";
    }

    private void button1_Click(object sender, System.EventArgs e)
    {
      fSpellCheck(textBox1, label1);
    }

    public void fSpellCheck(TextBox tBox, Label lLbl)
    {
      int iErrorCount = 0;
      Word._Application app = new Word.Application();

      if (textBox1.Text.Length > 0)
      {
        app.Visible = false; // ошибка
        object template = Missing.Value;
        object newTemplate = Missing.Value;
        object documentType = Missing.Value;
        object visible = false;
        object optional = Missing.Value;
        Word._Document doc = app.Documents.Add(ref template, ref newTemplate, ref documentType, ref visible);
        doc.Words.First.InsertBefore(tBox.Text);
        Word.ProofreadingErrors we = doc.SpellingErrors;
        iErrorCount = we.Count;

        doc.CheckSpelling(ref optional, ref optional, ref optional, ref optional,
          ref optional, ref optional, ref optional,
          ref optional, ref optional, ref optional, ref optional, ref optional);
        if (iErrorCount == 0)
          lLbl.Text = "Ошибок нет";
        else 
          lLbl.Text = "Проверка завершена. Обнаружено " + iErrorCount + " ошибок";
        object first = 0;
        object last = doc.Characters.Count - 1;

        tBox.Text = doc.Range(ref first, ref last).Text;
      }
      else
        lLbl.Text = "Поле для ввода текста пустое";
      object saveChanges = false;
      object originalFormat = Missing.Value;
      object routeDocument = Missing.Value;
      app.Quit(ref saveChanges, ref originalFormat, ref routeDocument); 
    }
  }
}